"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _app = _interopRequireDefault(require("../components/app"));

var _routerConfig = _interopRequireDefault(require("../shared/router-config"));

/* dts-imports
  import { ZMPParameters } from 'zmp-core/types';
*/

/* dts-extends
  ZMPParameters
*/

/* dts-props
  className?: string;
  style?: React.CSSProperties;
  COLOR_PROPS
*/
var ZMPApp = function ZMPApp(props) {
  var navbar = props.navbar,
      routes = props.routes;
  var navbarConfigs = (0, _extends2.default)({}, navbar, {
    iosCenterTitle: navbar && navbar.iosCenterTitle || false
  });
  var appRoutes = (0, _routerConfig.default)() || routes;
  return /*#__PURE__*/_react.default.createElement(_app.default, (0, _extends2.default)({}, props, {
    routes: appRoutes,
    navbar: navbarConfigs,
    iosTranslucentBars: false,
    iosTranslucentModals: false
  }));
};

ZMPApp.displayName = 'zmp-app';
var _default = ZMPApp;
exports.default = _default;