"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("../components/button"));

var _constants = require("../../common/constants");

var _utils = require("../shared/utils");

/* dts-props
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  text? : string
  tabLink? : boolean | string
  tabLinkActive? : boolean
  type? : string
  href? : string | boolean
  target? : string
  fill? : boolean
  large? : boolean
  small? : boolean
  active? : boolean
  disabled? : boolean
  tooltip? : string
  tooltipTrigger? : string
  preloader?: boolean;
  preloaderSize?: number | string;
  preloaderColor?: string;
  loading?: boolean;
  onClick? : (event?: any) => void;
  typeName: string
  responsive: boolean
  COLOR_PROPS
  ICON_PROPS
  ACTIONS_PROPS
*/
var ZMPButton = function ZMPButton(props) {
  var className = props.className,
      children = props.children,
      _props$typeName = props.typeName,
      typeName = _props$typeName === void 0 ? '' : _props$typeName,
      responsive = props.responsive;

  var getButtonTypeClass = function getButtonTypeClass() {
    var classPrefix = 'zmp-btn';

    switch (typeName) {
      case _constants.BUTTON_TYPE.PRIMARY:
        return classPrefix + "-primary";

      case _constants.BUTTON_TYPE.SECONDARY:
        return classPrefix + "-secondary";

      case _constants.BUTTON_TYPE.DESTRUCTIVE:
        return classPrefix + "-destructive";

      case _constants.BUTTON_TYPE.TERTIARY:
        return classPrefix + "-tertiary";

      case _constants.BUTTON_TYPE.GHOST:
        return classPrefix + "-ghost";

      default:
        return '';
    }
  };

  var typeClass = getButtonTypeClass();
  var classes = (0, _utils.classNames)(className, typeClass, responsive ? 'zmp-btn-responsive' : '');
  var buttonProps = (0, _extends2.default)({}, props, {
    className: classes
  });
  return /*#__PURE__*/_react.default.createElement(_button.default, buttonProps, children);
};

var _default = ZMPButton;
exports.default = _default;