"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _fab = _interopRequireDefault(require("../components/fab"));

var _utils = require("../shared/utils");

/* dts-props
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  morphTo? : string;
  href? : boolean | string;
  target? : string;
  text? : string;
  position? : string;
  tooltip? : string;
  tooltipTrigger? : string;
  onClick? : (event?: any) => void;
  large: boolean;
  small: boolean;
  disabled: boolean;
  COLOR_PROPS
*/
var ZMPFab = function ZMPFab(props) {
  var large = props.large,
      small = props.small,
      className = props.className,
      disabled = props.disabled;
  var sizeClass = '';

  if (small) {
    sizeClass = 'zmp-fab-small';
  } else if (large) {
    sizeClass = 'zmp-fab-large';
  }

  var classes = (0, _utils.classNames)(className, sizeClass, disabled ? 'disabled' : '');
  return /*#__PURE__*/_react.default.createElement(_fab.default, (0, _extends2.default)({}, props, {
    className: classes
  }));
};

var _default = ZMPFab;
exports.default = _default;