import { getWindow } from 'ssr-window';
import { resolvePath, toRoutePath, standardizePageDir } from '../../common/utils';
import { oldRouteConfig } from '../../common/regExp';
import { PAGE_DIR } from '../../common/constants';
var window = getWindow(); // eslint-disable-next-line no-var

var importPages;

try {
  if (process.env.NODE_ENV === 'production') {
    // eslint-disable-next-line no-undef
    importPages = ZMP_IMPORT_PAGES;
  } // eslint-disable-next-line no-empty

} catch (err) {}

var initRoutesForOldVersion = function initRoutesForOldVersion(routes, isOldConfig) {
  if (routes) {
    // eslint-disable-next-line no-param-reassign
    routes = routes.map(function (path, index) {
      var _resolvePath = resolvePath(path),
          _resolvePath$dir = _resolvePath.dir,
          dir = _resolvePath$dir === void 0 ? [] : _resolvePath$dir,
          fileName = _resolvePath.fileName;

      if (isOldConfig && index === 0) {
        return {
          path: '/',
          name: 'home',
          async: function async(_ref) {
            var resolve = _ref.resolve;
            var length = dir.length;

            switch (length) {
              case 0:
                import(
                /* @vite-ignore */
                "../../../src/" + PAGE_DIR + "/" + fileName + ".jsx").then(function (res) {
                  resolve({
                    component: res.default
                  });
                });
                break;

              case 1:
                import(
                /* @vite-ignore */
                "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + fileName + ".jsx").then(function (res) {
                  resolve({
                    component: res.default
                  });
                });
                break;

              case 2:
                import(
                /* @vite-ignore */
                "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + dir[1] + "/" + fileName + ".jsx").then(function (res) {
                  resolve({
                    component: res.default
                  });
                });
                break;

              case 3:
                import(
                /* @vite-ignore */
                "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + dir[1] + "/" + dir[2] + "/" + fileName + ".jsx").then(function (res) {
                  resolve({
                    component: res.default
                  });
                });
                break;

              case 4:
                import(
                /* @vite-ignore */
                "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + dir[1] + "/" + dir[2] + "/" + dir[3] + "/" + fileName + ".jsx").then(function (res) {
                  resolve({
                    component: res.default
                  });
                });
                break;

              default:
                import(
                /* @vite-ignore */
                "../../../src/" + PAGE_DIR + "/" + fileName + ".jsx").then(function (res) {
                  resolve({
                    component: res.default
                  });
                });
            }
          }
        };
      }

      var _toRoutePath = toRoutePath(path),
          routePath = _toRoutePath.path;

      var alias;

      if (routePath) {
        alias = routePath.substring(0, routePath.length - 1);
      }

      var routeObj = {
        path: routePath,
        async: function async(_ref2) {
          var resolve = _ref2.resolve;
          var length = dir.length;

          switch (length) {
            case 0:
              import(
              /* @vite-ignore */
              "../../../src/" + PAGE_DIR + "/" + fileName + ".jsx").then(function (res) {
                resolve({
                  component: res.default
                });
              });
              break;

            case 1:
              import(
              /* @vite-ignore */
              "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + fileName + ".jsx").then(function (res) {
                resolve({
                  component: res.default
                });
              });
              break;

            case 2:
              import(
              /* @vite-ignore */
              "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + dir[1] + "/" + fileName + ".jsx").then(function (res) {
                resolve({
                  component: res.default
                });
              });
              break;

            case 3:
              import(
              /* @vite-ignore */
              "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + dir[1] + "/" + dir[2] + "/" + fileName + ".jsx").then(function (res) {
                resolve({
                  component: res.default
                });
              });
              break;

            case 4:
              import(
              /* @vite-ignore */
              "../../../src/" + PAGE_DIR + "/" + dir[0] + "/" + dir[1] + "/" + dir[2] + "/" + dir[3] + "/" + fileName + ".jsx").then(function (res) {
                resolve({
                  component: res.default
                });
              });
              break;

            default:
              import(
              /* @vite-ignore */
              "../../../src/" + PAGE_DIR + "/" + fileName + ".jsx").then(function (res) {
                resolve({
                  component: res.default
                });
              });
          }
        }
      };

      if (alias) {
        routeObj.alias = alias;
      }

      return routeObj;
    });

    if (!isOldConfig) {
      // eslint-disable-next-line no-param-reassign
      routes = [{
        path: '/',
        async: function async(_ref3) {
          var resolve = _ref3.resolve;
          import(
          /* @vite-ignore */
          "../../../src/" + PAGE_DIR + "/index.jsx").then(function (res) {
            resolve({
              component: res.default
            });
          });
        }
      }].concat(routes);
    }
  }

  return routes;
};

var initRoutes = function initRoutes(routes, isOldConfig) {
  var appRoutes;

  if (routes && importPages) {
    appRoutes = routes.map(function (path, index) {
      var _toRoutePath2 = toRoutePath(path),
          routePath = _toRoutePath2.path,
          fileDir = _toRoutePath2.fileDir;

      if (isOldConfig && index === 0) {
        return {
          path: '/',
          name: 'home',
          async: function async(_ref4) {
            var resolve = _ref4.resolve;

            if (!importPages[fileDir]) {
              throw Error("Cannot find /" + fileDir);
            }

            importPages[fileDir]().then(function (res) {
              resolve({
                component: res.default
              });
            });
          }
        };
      }

      var alias;

      if (routePath) {
        alias = routePath.substring(0, routePath.length - 1);
      }

      var routeObj = {
        path: routePath,
        async: function async(_ref5) {
          var resolve = _ref5.resolve;

          if (!importPages[fileDir]) {
            throw Error("Cannot find /" + fileDir);
          }

          importPages[fileDir]().then(function (res) {
            resolve({
              component: res.default
            });
          });
        }
      };

      if (alias) {
        routeObj.alias = alias;
      }

      return routeObj;
    });

    if (!isOldConfig) {
      appRoutes = [{
        path: '/',
        name: 'home',
        async: function async(_ref6) {
          var resolve = _ref6.resolve;

          if (!importPages.index) {
            throw Error('Can not find Index Page');
          }

          importPages.index().then(function (res) {
            resolve({
              component: res.default
            });
          });
        }
      }].concat(appRoutes);
    }
  }

  return appRoutes;
};

var initDevRouter = function initDevRouter(routes, isOldConfig) {
  if (routes) {
    // eslint-disable-next-line no-param-reassign
    routes = routes.map(function (path, index) {
      var _resolvePath2 = resolvePath(path),
          _resolvePath2$dir = _resolvePath2.dir,
          dir = _resolvePath2$dir === void 0 ? [] : _resolvePath2$dir,
          fileName = _resolvePath2.fileName;

      var pathToPage = '';

      if (dir.length) {
        pathToPage = dir.join('/') + "/";
      }

      if (isOldConfig && index === 0) {
        return {
          path: '/',
          name: 'home',
          async: function async(_ref7) {
            var resolve = _ref7.resolve;
            import(
            /* @vite-ignore */
            "/src/" + PAGE_DIR + "/" + pathToPage + fileName).then(function (res) {
              resolve({
                component: res.default
              });
            });
          }
        };
      }

      var _toRoutePath3 = toRoutePath(path),
          routePath = _toRoutePath3.path;

      var alias;

      if (routePath) {
        alias = routePath.substring(0, routePath.length - 1);
      }

      var routeObj = {
        path: routePath,
        async: function async(_ref8) {
          var resolve = _ref8.resolve;
          import(
          /* @vite-ignore */
          "/src/" + PAGE_DIR + "/" + pathToPage + fileName).then(function (res) {
            resolve({
              component: res.default
            });
          });
        }
      };

      if (alias) {
        routeObj.alias = alias;
      }

      return routeObj;
    });

    if (!isOldConfig) {
      // eslint-disable-next-line no-param-reassign
      routes = [{
        path: '/',
        async: function async(_ref9) {
          var resolve = _ref9.resolve;
          import(
          /* @vite-ignore */
          "/src/" + PAGE_DIR + "/index").then(function (res) {
            resolve({
              component: res.default
            });
          });
        }
      }].concat(routes);
    }
  }

  return routes;
};

export default (function () {
  var routes;

  if (window.APP_CONFIG) {
    routes = window.APP_CONFIG.pages;
  }

  if (routes) {
    var isOldConfig = false;

    if (routes.length && routes[0] && oldRouteConfig.test(routes[0])) {
      isOldConfig = true;
    }

    routes = routes.map(function (route) {
      return standardizePageDir(route);
    }); // eslint-disable-next-line no-restricted-globals

    if (process.env.NODE_ENV === 'production') {
      routes = importPages ? initRoutes(routes, isOldConfig) : initRoutesForOldVersion(routes, isOldConfig);
    } else {
      routes = initDevRouter(routes, isOldConfig);
    }
  }

  return routes;
});