import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import App from '../components/app';
import routesConfig from '../shared/router-config';
/* dts-imports
  import { ZMPParameters } from 'zmp-core/types';
*/

/* dts-extends
  ZMPParameters
*/

/* dts-props
  className?: string;
  style?: React.CSSProperties;
  COLOR_PROPS
*/

var ZMPApp = function ZMPApp(props) {
  var navbar = props.navbar,
      routes = props.routes;

  var navbarConfigs = _extends({}, navbar, {
    iosCenterTitle: navbar && navbar.iosCenterTitle || false
  });

  var appRoutes = routesConfig() || routes;
  return /*#__PURE__*/React.createElement(App, _extends({}, props, {
    routes: appRoutes,
    navbar: navbarConfigs,
    iosTranslucentBars: false,
    iosTranslucentModals: false
  }));
};

ZMPApp.displayName = 'zmp-app';
export default ZMPApp;