import _extends from "@babel/runtime/helpers/extends";
import React, { useRef, forwardRef, useImperativeHandle } from 'react';
import Progressbar from '../components/progressbar';
/* dts-props
  id?: string | number;
  className?: string;
  style?: React.CSSProperties;
  progress? : number;
  infinite? : boolean;
*/

var ZMPProgressbar = /*#__PURE__*/forwardRef(function (props, ref) {
  var elRef = useRef(null);
  useImperativeHandle(ref, function () {
    return elRef.current;
  });
  return /*#__PURE__*/React.createElement(Progressbar, _extends({
    ref: elRef,
    color: null
  }, props));
});
ZMPProgressbar.displayName = 'zmp-progressbar';
export default ZMPProgressbar;